require 'glottis/exceptions/user_exited_exception'
require 'readline'

module Glottis
  module Handlers
    # This class holds a reference to the outgoing message queue,
    # and posts messages to it from the console as they are entered.
    class ConsoleInputHandler < Thread
      USER_PROMPT = '> '.freeze

      def initialize(outgoing)
        @outgoing = outgoing
        super do
          loop do
            user_input = Readline.readline(USER_PROMPT)
            Readline::HISTORY.push(user_input)

            # if user_input.nil?
            #   raise Glottis::Exceptions::UserExitedException.new
            # end

            @outgoing.push(user_input)
          end
        end
      end

      def cleanup
        # do nothing
      end
    end # ConsoleInputHandler
  end # Handlers
end # Glottis
