module Glottis
  module Handlers
    # This class holds a reference to the incoming message queue,
    # and displays messages in the console as they are received.
    class ConsoleOutputHandler < Thread
      def initialize(incoming)
        @incoming = incoming
        super do
          loop do
            new_msg = @incoming.pop
            puts "#{new_msg['from']}, #{new_msg['to']}, #{new_msg['msg']}"
          end
        end
      end

      def cleanup
        puts '|'
      end
    end # ConsoleOutputHandler
  end # Handlers
end # Glottis
